﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Data.SqlClient;
using System.Web.Configuration;
using Syncfusion.JavaScript.Shared.Serializer;

namespace userselectionview.Controllers

{
    
   
  
    public class BusinessObject
    {
        public int TaskId
        {    get; set;
        }

        public string TaskName
        {
            get;
            set;
        }

        public string StartDate
        {
            get;
            set;
        }

        public string EndDate
        {
            get;
            set;
        }

        public int Duration
        {
            get;
            set;
        }

        public int Progress
        {
            get;
            set;
        }     

        public List<BusinessObject> Children
        {
            get;
            set;
        }

        public int? ParentId
        {
            get;
            set;
        }

    }
    public class GanttController : Controller
    {
        // GET: TreeGrid
        public ActionResult Index()
        {
                                
            ViewBag.datasource = this.GetPlanDataSource();
            DataManagerConverter.Serializer = new DMSerial();
            return View();
        }    
       
        
        

        private List<BusinessObject> GetDesignDataSource(int value)
        {
            List<BusinessObject> list = new List<BusinessObject>();
            var x = 0;
            for (var i = 0; i < value; i++)
            {
                list.Add(new BusinessObject()
                {
                    TaskId = ++x,
                    TaskName = "Task New" + (i + 1),
                    Progress = 50,
                    StartDate = "01/17/2010",
                    Duration = 5,

                    Children = (new List<BusinessObject>()
                        {
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 1",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 5
                            },
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 2",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 5,
                            },
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 3",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 5,
                            }
                        })

                });

            }


            return list;
        }

        private List<BusinessObject> GetPlanDataSource()
            {
                List<BusinessObject> list = new List<BusinessObject>();
                var x = 0;
                for (var i = 0; i < 5; i++)
                {
                    list.Add(new BusinessObject()
                    {
                        TaskId = ++x,
                        TaskName = "Task" + (i + 1),
                        Progress = 50,
                        StartDate = "01/17/2010",
                        Duration = 5,

                        Children = (new List<BusinessObject>()
                        {
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 1",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 5
                            },
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 2",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 5,
                            },
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 3",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 5,
                            }
                        })

                    });

                }


                return list;
            }
        public class DMSerial : IDataSourceSerializer
        {

            public string Serialize(object obj)
            {   
                var str = Newtonsoft.Json.JsonConvert.SerializeObject(obj);
                return str;
            }
        }

        [HttpGet]
        public ActionResult _Gantt(int id)
        {
            var DataSource = this.GetDesignDataSource(id);
            ViewBag.datasource = DataSource;           
            DataManagerConverter.Serializer = new DMSerial();
            return PartialView("_Gantt", DataSource);
           
        }
        }
    }
